VERSION 5.00
Begin VB.Form frmTransparentRegions 
   ClientHeight    =   3465
   ClientLeft      =   1530
   ClientTop       =   1500
   ClientWidth     =   4200
   Icon            =   "frmTransparentRegions.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   231
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   280
   Begin VB.CommandButton Command1 
      Caption         =   "Close Me"
      Height          =   495
      Left            =   1500
      TabIndex        =   0
      Top             =   1485
      Width           =   1215
   End
End
Attribute VB_Name = "frmTransparentRegions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to use the region API functions
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  Private Const RGN_AND  As Long = 1&  ' <- returns only the parts that are common to both
  Private Const RGN_OR  As Long = 2&   ' <- returns a region that contains the area of both
  Private Const RGN_XOR  As Long = 3&  ' <- returns only the parts that don't overlap
  Private Const RGN_DIFF  As Long = 4& ' <- subtracts one region from another
  Private Const RGN_COPY  As Long = 5& ' <- copies a region

  Private Declare Function CreateRectRgn& Lib "gdi32" (ByVal X1&, ByVal Y1&, ByVal X2&, ByVal Y2&)
  Private Declare Function CreateEllipticRgn& Lib "gdi32" (ByVal X1&, ByVal Y1&, ByVal X2&, ByVal Y2&)
  Private Declare Function CombineRgn& Lib "gdi32" (ByVal hDestRgn&, ByVal hSrcRgn1&, ByVal hSrcRgn2&, ByVal nCombineMode&)
  Private Declare Function SetWindowRgn& Lib "user32" (ByVal hWnd&, ByVal hRgn&, ByVal bRedraw&)
  Private Declare Function DeleteObject& Lib "gdi32" (ByVal hObject&)

Private Sub Form_Resize()
  
  Dim hOuterRgn&, hInnerRgn&, hIslandRgn&, hRegion&
  Dim nWidth&, nHeight&, nNCBorderWidth&, nNCBorderHeight&

  If WindowState = vbMinimized Then Exit Sub
  
  ' get the width and height of the form in pixels
  nWidth = ScaleX(Width, vbTwips, vbPixels)
  nHeight = ScaleY(Height, vbTwips, vbPixels)
  
  ' create a region the size of the form
  hOuterRgn = CreateRectRgn(0&, 0&, nWidth, nHeight)
  
  ' Determine the size of the borders of the form (this could be done using a call to GetClientRect also)
  nNCBorderWidth = (nWidth - ScaleWidth) / 2
  nNCBorderHeight = nHeight - nNCBorderWidth - ScaleHeight
  

  ' comment the next line and uncomment the following line to see different effects
  hInnerRgn = CreateRectRgn(nNCBorderWidth, nNCBorderHeight, _
                        ScaleWidth + nNCBorderWidth, ScaleHeight + nNCBorderHeight)
      
  'hInnerRgn = CreateEllipticRgn(nNCBorderWidth + ScaleWidth * 0.1, _
        nNCBorderHeight + ScaleHeight * 0.1, ScaleWidth * 0.9, ScaleHeight * 0.9)


  ' add an island the size of the command button to the center of the form
  hIslandRgn = CreateRectRgn(nNCBorderWidth + Command1.Left, nNCBorderHeight + Command1.Top, _
          (nNCBorderWidth + Command1.Left) + Command1.Width, (nNCBorderHeight + Command1.Top) + Command1.Height)
  
  CombineRgn hInnerRgn, hInnerRgn, hIslandRgn, RGN_DIFF


  ' creat a dummy region to hold the region created by CombineRgn
  hRegion = CreateRectRgn(0&, 0&, 10&, 10&)
  
  ' Subtract the inner region from the outer.
  CombineRgn hRegion, hOuterRgn, hInnerRgn, RGN_DIFF
  
  ' clean up after ourselves
  DeleteObject hOuterRgn
  DeleteObject hInnerRgn
  DeleteObject hIslandRgn
  
  ' assign the region to the window
  SetWindowRgn hWnd, hRegion, True
  
End Sub

Private Sub Command1_Click()
  Unload Me
End Sub

